unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin, fgl;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

uses
  TupleU;

var
  tlist: TTupleList;

procedure TForm1.FormCreate(Sender: TObject);
var
  i, j: Integer;
begin
  Randomize;
  tlist := TTupleList.Create;
  //add data
  for i := 0 to 1000 do
  begin
    for j := 1 to 20 do
    begin
      if Random(10) <> 2 then
        tlist.Add(i, j, [3.14, 5.16, 7.18, 9.2]);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i, j, idx: Integer;
  sarr: TSpannungstensorArray;
begin
  Memo1.Lines.Clear;
  if SpinEdit2.Value <> 0 then
  begin
    sarr := tlist.Get(SpinEdit1.Value, SpinEdit2.Value);
    for i := 0 to High(sarr) do
      Memo1.Lines.Add(FloatToStr(sarr[i]));
  end
  else
  begin
    idx := tlist.IndexOf(SpinEdit1.Value);
    if idx >= 0 then
    begin
      for i := 0 to tlist.Data[idx].Count - 1 do
      begin
        sarr := tlist.Data[idx].Data[i];
        for j := 0 to High(sarr) do
          Memo1.Lines.Add(IntToStr(tlist.Data[idx].Keys[i]) + ' > ' + FloatToStr(sarr[j]));
      end;
    end;
  end;
  if Memo1.Lines.Count = 0 then
  begin
    if SpinEdit2.Value = 0 then
      Memo1.Lines.Add(Format('ElementID: %d not exists!', [SpinEdit1.Value]))
    else
      Memo1.Lines.Add(Format('Tuple [ElementID: %d, KnotenID: %d] not exists!', [SpinEdit1.Value, SpinEdit2.Value]));
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if SpinEdit2.Value = 0 then
  begin
    ShowMessage('KnotenId must be different from 0!');
    exit;
  end;
  tlist.Add(SpinEdit1.Value, SpinEdit2.Value, Single(Random(20) / 17));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if SpinEdit2.Value = 0 then
    tlist.Delete(SpinEdit1.Value)
  else
    tlist.Delete(SpinEdit1.Value, SpinEdit2.Value);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  tlist.Free;
end;

end.

